<?php
/**
 * AdminKladr
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 21.01.2015
 * @since 1.0.0
 */

namespace skeeks\modules\cms\kladr\actions;
use skeeks\cms\base\db\ActiveRecord;
use Yii;
use yii\base\Action;

/**
 * Class AdminKladr
 * @package skeeks\modules\cms\kladr\actions
 */
class AdminKladr extends \skeeks\cms\base\Action
{
    /**
     * @var string the view file to be rendered. If not set, it will take the value of [[id]].
     * That means, if you name the action as "error" in "SiteController", then the view name
     * would be "error", and the corresponding view file would be "views/site/error.php".
     */
    public $view;

    /**
     * @var Model|null
     */
    protected $_model = null;

    /**
     * @var
     */
    public $callback;

    /**
     * Runs the action
     *
     * @return string result content
     */
    public function run()
    {
        /**
         * @var $model ActiveRecord
         */
        $model = $this->controller->getCurrentModel();

        $content = \Yii::$app->getModule('kladr')->renderFile('admin-actions/kladr.php', [
            'model' => $model
        ]);

        if (\Yii::$app->request->post())
        {
            $model->setAttributes(\Yii::$app->request->post(), false);
            if ($model->save(false))
            {
                \Yii::$app->getSession()->setFlash('success', 'Успешно сохранено');
            }
            return $this->redirect(['update', 'id' => $model->id]);
        } else
        {

            if (\Yii::$app->request->isPost)
            {
                \Yii::$app->getSession()->setFlash('error', 'Не удалось сохранить');
            }

            return $this->controller->output($content);
        }
    }
}