<?php
/**
 * AdminCountryController
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 20.01.2015
 * @since 1.0.0
 */
namespace skeeks\modules\cms\kladr\controllers;

use skeeks\cms\models\Comment;
use skeeks\cms\models\Publication;
use skeeks\cms\models\searchs\Publication as PublicationSearch;
use skeeks\cms\modules\admin\controllers\AdminController;
use skeeks\cms\modules\admin\controllers\AdminModelEditorSmartController;
use skeeks\cms\modules\admin\controllers\AdminModelEditorController;
use skeeks\cms\modules\admin\controllers\helpers\rules\NoModel;
use skeeks\modules\cms\kladr\helpers\Updater;
use skeeks\modules\cms\kladr\helpers\VkApi;
use skeeks\modules\cms\kladr\helpers\YandexGeocode;
use skeeks\modules\cms\kladr\models\Country;
use Yii;
use skeeks\cms\models\User;
use skeeks\cms\models\searchs\User as UserSearch;
use yii\helpers\ArrayHelper;

/**
 * Class AdminUserController
 * @package skeeks\cms\controllers
 */
class AdminCountryController extends AdminModelEditorSmartController
{
    public function init()
    {
        $this->_label                   = "Управление странами";

        $this->_modelShowAttribute      = "name";
        $this->_modelClassName          = Country::className();

        parent::init();

    }


    /**
     * @return array
     */
    public function behaviors()
    {
        return ArrayHelper::merge(parent::behaviors(), [

            self::BEHAVIOR_ACTION_MANAGER =>
                [
                    "actions" =>
                        [
                            /*'parse' =>
                                [
                                    "label" => "Обновить список",
                                    "icon" => "glyphicon glyphicon-paperclip",
                                    "rules" =>
                                        [
                                            [
                                                "class" => NoModel::className(),
                                            ]
                                        ]
                                ],*/
                        ]
                ]
        ]);
    }

    public function actionParse()
    {
        if (\Yii::$app->request->isPost)
        {
            Updater::countriesUpdate();
        }

        return $this->render('parse');
    }
}
