<?php
/**
 * AjaxController
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 21.01.2015
 * @since 1.0.0
 */
namespace skeeks\modules\cms\kladr\controllers;

use skeeks\cms\base\Controller;
use skeeks\cms\models\User;
use skeeks\cms\modules\admin\components\UrlRule;
use skeeks\cms\modules\admin\controllers\AdminController;
use skeeks\cms\rbac\AuthorRule;
use skeeks\modules\cms\kladr\helpers\Updater;
use skeeks\modules\cms\kladr\models\AdministrativeArea;
use skeeks\modules\cms\kladr\models\City;
use skeeks\modules\cms\kladr\models\Country;
use skeeks\modules\cms\kladr\models\Locality;
use skeeks\modules\cms\kladr\models\Metro;
use skeeks\modules\cms\kladr\models\Region;
use skeeks\modules\cms\kladr\models\Road;
use skeeks\modules\cms\kladr\models\SubAdministrativeArea;
use Yii;
use yii\helpers\Console;

class AjaxController extends Controller
{

    public function actionRegions()
    {
        $response =
        [
            'success' => false
        ];

        Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
        $request = Yii::$app->getRequest();

        $kladr_country_id = $request->post('kladr_country_id');
        if ($kladr_country_id)
        {
            $administrativeAreas = Region::find()->where(['kladr_country_id' => $kladr_country_id])->all();
            $response['items']      = $administrativeAreas;
            $response['success']    = true;

        } else
        {

        }


        return $response;
    }

    public function actionCities()
    {
        $response =
        [
            'success' => false
        ];

        Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
        $request = Yii::$app->getRequest();

        $kladr_region_id = $request->post('kladr_region_id');
        if ($kladr_region_id)
        {
            $items = City::find()->where(['kladr_region_id' => $kladr_region_id])->all();

            $response['items'] = $items;
            $response['success'] = true;

        } else
        {}


        return $response;
    }

    public function actionMetro()
    {
        $response =
        [
            'success' => false
        ];

        Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
        $request = Yii::$app->getRequest();

        $kladr_city_id = $request->post('kladr_city_id');
        if ($kladr_city_id)
        {
            $items = Metro::find()->where(['kladr_city_id' => $kladr_city_id])->all();

            $response['items'] = $items;
            $response['success'] = true;

        } else
        {}


        return $response;
    }

    public function actionRoads()
    {
        $response =
        [
            'success' => false
        ];

        Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
        $request = Yii::$app->getRequest();

        $kladr_city_id = $request->post('kladr_city_id');
        if ($kladr_city_id)
        {
            $items = Road::find()->where(['kladr_city_id' => $kladr_city_id])->all();

            $response['items'] = $items;
            $response['success'] = true;

        } else
        {}


        return $response;
    }
}