<?php
/**
 * UpdateController
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 21.01.2015
 * @since 1.0.0
 */
namespace skeeks\modules\cms\kladr\controllers;

use skeeks\cms\base\console\Controller;
use skeeks\cms\models\User;
use skeeks\cms\modules\admin\components\UrlRule;
use skeeks\cms\modules\admin\controllers\AdminController;
use skeeks\cms\rbac\AuthorRule;
use skeeks\modules\cms\kladr\helpers\Updater;
use skeeks\modules\cms\kladr\models\Country;
use Yii;
use yii\helpers\Console;

class UpdateController extends Controller
{
    /**
     * @return Country
     */
    protected function _fetchRussia()
    {
        $country = Country::find()->where(["code" => 'ru'])->one();
        $this->stdoutN("Find russia");

        if ($country)
        {
            $this->stdoutN("Russia is finded id: " . $country->id);
            return $country;
        }
        return null;
    }

    public function actionRussiaAll()
    {
        $this->actionCounties()->actionRussiaRegion()->actionRussiaLocality();
        $this->stdoutN("ready");
    }

    public function actionCountry()
    {
        $this->stdoutN("Update countries");
        Updater::countriesUpdate();
        return $this;
    }

    /**
     * @return $this
     */
    public function actionRussiaRegion()
    {
        $country = $this->_fetchRussia();
        if (!$country)
        {
            $this->stdoutN("NotFound Russia");
            return;
        }

        $this->stdoutN("Update regions");
        Updater::regionUpdate($country->id);

        return $this;
    }

    /**
     * @return $this
     */
    public function actionRussiaLocality()
    {
        $country = $this->_fetchRussia();
        if (!$country)
        {
            $this->stdoutN("NotFound Russia");
            return;
        }

        $this->stdoutN("Update regions");
        Updater::cityUpdate($country->id);

        return $this;
    }
}