<?php
/**
 * Autoru
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 22.01.2015
 * @since 1.0.0
 */
namespace skeeks\modules\cms\kladr\helpers;

use skeeks\cms\models\Comment;
use skeeks\cms\models\Publication;
use skeeks\cms\models\searchs\Publication as PublicationSearch;
use skeeks\cms\modules\admin\controllers\AdminController;
use skeeks\cms\modules\admin\controllers\AdminModelEditorSmartController;
use skeeks\cms\modules\admin\controllers\AdminModelEditorController;
use skeeks\modules\cms\kladr\models\AdministrativeArea;
use skeeks\modules\cms\kladr\models\Country;
use Yii;
use skeeks\cms\models\User;
use skeeks\cms\models\searchs\User as UserSearch;
use yii\base\Component;
use yii\helpers\Json;

class Autoru extends Component
{
    static public $baseApiUrl = 'http://anonymouse.org/cgi-bin/anon-www.cgi/http://auto.ru/ajax/'; //.getCountries?v=5.5&need_all=1&count=255';

    /**
     * @param $methodName
     * @return string
     */
    static public function getMethodUrl($methodName)
    {
        return self::$baseApiUrl . $methodName . '/';
    }

    /**
     * @param $method
     * @param array $queryData
     * @return array
     */
    public function request($url)
    {
        $json = file_get_contents($url);
        $json = substr($json, 0, strpos($json, '<style'));

        $result = (array) Json::decode($json);
        if ($result['result'] === false)
        {
            return [];
        }

        return $result['data'];
    }

    /**
     * @return array
     */
    static public function getRegions($country_id)
    {
        return (new self())->request(self::getMethodUrl('get_regions') . $country_id);
    }


    /**
     * @param $country_id
     * @return array
     */
    static public function getCities($region_id)
    {
        return (new self())->request(self::getMethodUrl('get_cities') . $region_id);
    }
}