<?php
/**
 * YandexGeocode
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 20.01.2015
 * @since 1.0.0
 */

namespace skeeks\modules\cms\kladr\helpers;

use skeeks\cms\models\Comment;
use skeeks\cms\models\Publication;
use skeeks\cms\models\searchs\Publication as PublicationSearch;
use skeeks\cms\modules\admin\controllers\AdminController;
use skeeks\cms\modules\admin\controllers\AdminModelEditorSmartController;
use skeeks\cms\modules\admin\controllers\AdminModelEditorController;
use skeeks\modules\cms\kladr\models\AdministrativeArea;
use skeeks\modules\cms\kladr\models\Country;
use Yii;
use skeeks\cms\models\User;
use skeeks\cms\models\searchs\User as UserSearch;
use yii\base\Component;
use yii\helpers\Json;

class YandexGeocode extends Component
{
    protected $_baseApiUrl = 'http://geocode-maps.yandex.ru/1.x/';

    /**
     * @param $geocodeString
     * @return YandexGeocodeResult
     */
    public function request($geocodeString)
    {
        $requestData = [
            "geocode" => $geocodeString,
            "results" => 10000,
            "format" => 'json'
        ];

        $result = file_get_contents($this->_baseApiUrl . '?' . http_build_query($requestData));
        $result = Json::decode($result);

        return new YandexGeocodeResult((array) $result['response']['GeoObjectCollection']);
    }


    /**
     *
     */
    static public function updateCountries()
    {

    }
}