<?php
/**
 * YandexGeocodeResult
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 20.01.2015
 * @since 1.0.0
 */
namespace skeeks\modules\cms\kladr\helpers;

use skeeks\cms\models\Comment;
use skeeks\cms\models\Publication;
use skeeks\cms\models\searchs\Publication as PublicationSearch;
use skeeks\cms\modules\admin\controllers\AdminController;
use skeeks\cms\modules\admin\controllers\AdminModelEditorSmartController;
use skeeks\cms\modules\admin\controllers\AdminModelEditorController;
use skeeks\modules\cms\kladr\models\AdministrativeArea;
use skeeks\modules\cms\kladr\models\Country;
use skeeks\sx\Entity;
use Yii;
use skeeks\cms\models\User;
use skeeks\cms\models\searchs\User as UserSearch;
use yii\base\Component;
use yii\helpers\ArrayHelper;

class YandexGeocodeResult extends Entity
{
    /**
     * @return array
     */
    public function getMetadata()
    {
        return (array) ArrayHelper::getValue($this->get('metaDataProperty'), 'GeocoderResponseMetaData');
    }

    /**
     * @return int
     */
    public function getFoundTotal()
    {
        return (int) ArrayHelper::getValue($this->getMetadata(), 'found');
    }

    /**
     * @return YndexResultGeoObject[]
     */
    public function getResults()
    {
        $results = (array) $this->get('featureMember');

        $res = [];
        if ($results)
        {
            foreach ($results as $key => $value)
            {
                $res[] = new YndexResultGeoObject($value['GeoObject']);
            }
        }

        return $res;
    }
}