<?php
/**
 * YndexResultGeoObject
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 20.01.2015
 * @since 1.0.0
 */
namespace skeeks\modules\cms\kladr\helpers;

use skeeks\cms\models\Comment;
use skeeks\cms\models\Publication;
use skeeks\cms\models\searchs\Publication as PublicationSearch;
use skeeks\cms\modules\admin\controllers\AdminController;
use skeeks\cms\modules\admin\controllers\AdminModelEditorSmartController;
use skeeks\cms\modules\admin\controllers\AdminModelEditorController;
use skeeks\modules\cms\kladr\models\AdministrativeArea;
use skeeks\modules\cms\kladr\models\Country;
use skeeks\sx\Entity;
use skeeks\sx\String;
use Yii;
use skeeks\cms\models\User;
use skeeks\cms\models\searchs\User as UserSearch;
use yii\base\Component;
use yii\helpers\ArrayHelper;

class YndexResultGeoObject extends Entity
{

    /**
     * @return array
     */
    public function getMetadata()
    {
        return (array) ArrayHelper::getValue($this->get('metaDataProperty'), 'GeocoderMetaData');
    }

    /**
     * @return string
     */
    public function getDescription()
    {
        return (string) $this->get('description');
    }

    /**
     * @return string
     */
    public function getName()
    {
        return (string) $this->get('name');
    }

    /**
     * @return array
     */
    public function getBoundedBy()
    {
        return (array) $this->get('boundedBy');
    }

    /**
     * @return array
     */
    public function getPoint()
    {
        return (array) $this->get('Point')['pos'];
    }


    /**
     * @return string
     */
    public function getKind()
    {
        return (string) ArrayHelper::getValue($this->getMetadata(), 'kind');
    }

    /**
     * @return string
     */
    public function getFullAddress()
    {
        return (string) ArrayHelper::getValue($this->getMetadata(), 'text');
    }

    /**
     * @return string
     */
    public function getAddressDetails()
    {
        $array = (array) ArrayHelper::getValue($this->getMetadata(), 'AddressDetails');
        $array = (array) ArrayHelper::getValue($array, 'Country');

        return $array;
    }

    /**
     * @return string
     */
    public function getCountryName()
    {
        return (string) ArrayHelper::getValue($this->getAddressDetails(), 'CountryName');
    }


    /**
     * @return string
     */
    public function getCountryNameCode()
    {
        return (string) String::strtolower(ArrayHelper::getValue($this->getAddressDetails(), 'CountryNameCode'));
    }
}