<?php
/**
 * m150119_100558_create_table__kladr_country
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 20.01.2015
 * @since 1.0.0
 */
use yii\db\Schema;
use yii\db\Migration;

class m150119_100558_create_table__kladr_country extends Migration
{
    public function up()
    {
        $tableExist = $this->db->getTableSchema("{{%kladr_country}}", true);
        if ($tableExist)
        {
            return true;
        }

        $tableOptions = null;
        if ($this->db->driverName === 'mysql') {
            $tableOptions = 'CHARACTER SET utf8 COLLATE utf8_general_ci ENGINE=InnoDB';
        }

        $this->createTable("{{%kladr_country}}", [
            'id'                    => Schema::TYPE_PK,

            'name'                  => Schema::TYPE_STRING. '(255) NOT NULL',
            'name_full'             => Schema::TYPE_STRING. '(255) NULL',
            'name_where'            => Schema::TYPE_STRING. '(255) NULL',

            'domain'                => Schema::TYPE_STRING. '(10) NULL',

            'dialcode'              => Schema::TYPE_STRING. '(10) NULL',
            'important'             => Schema::TYPE_SMALLINT . ' NOT NULL DEFAULT 0', //статус, активна некативна, удалено

            'lat'                   => Schema::TYPE_STRING. '(20) NULL',
            'lng'                   => Schema::TYPE_STRING. '(20) NULL',

            'description_short'     => Schema::TYPE_TEXT,
            'description_full'      => Schema::TYPE_TEXT,

            'files'                 => Schema::TYPE_TEXT. ' NULL', //

            'status'                => Schema::TYPE_SMALLINT . ' NOT NULL DEFAULT 10', //статус, активна некативна, удалено

            'vk_id'                 => Schema::TYPE_INTEGER . ' NULL',
            'autoru_id'             => Schema::TYPE_INTEGER . ' NULL',

        ], $tableOptions);

        $this->execute("ALTER TABLE {{%kladr_country}} ADD UNIQUE(domain);");

        $this->execute("ALTER TABLE {{%kladr_country}} ADD INDEX(lat);");
        $this->execute("ALTER TABLE {{%kladr_country}} ADD INDEX(lng);");
        $this->execute("ALTER TABLE {{%kladr_country}} ADD UNIQUE(vk_id);");
        $this->execute("ALTER TABLE {{%kladr_country}} ADD INDEX(important);");
        $this->execute("ALTER TABLE {{%kladr_country}} ADD UNIQUE(autoru_id);");
        $this->execute("ALTER TABLE {{%kladr_country}} ADD INDEX(name);");
        $this->execute("ALTER TABLE {{%kladr_country}} ADD INDEX(name_where);");
        $this->execute("ALTER TABLE {{%kladr_country}} ADD INDEX(dialcode);");
        $this->execute("ALTER TABLE {{%kladr_country}} ADD INDEX(name_full);");


        $this->execute("ALTER TABLE {{%kladr_country}} ADD INDEX(status);");

        $this->execute("ALTER TABLE {{%kladr_country}} COMMENT = 'Страны';");

    }

    public function down()
    {
        $this->dropTable("{{%kladr_country}}");
    }
}
