<?php
/**
 * m150119_120559_create_table__kladr_city
 * 
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 22.01.2015
 * @since 1.0.0
 */
use yii\db\Schema;
use yii\db\Migration;

class m150119_120559_create_table__kladr_city extends Migration
{
    public function up()
    {
        $tableExist = $this->db->getTableSchema("{{%kladr_city}}", true);
        if ($tableExist)
        {
            return true;
        }

        $tableOptions = null;
        if ($this->db->driverName === 'mysql') {
            $tableOptions = 'CHARACTER SET utf8 COLLATE utf8_general_ci ENGINE=InnoDB';
        }

        $this->createTable("{{%kladr_city}}", [
            'id'                    => Schema::TYPE_PK,

            'name'                  => Schema::TYPE_STRING. '(255) NOT NULL',
            'name_full'             => Schema::TYPE_STRING. '(255) NULL',
            'name_where'            => Schema::TYPE_STRING. '(255) NULL',

            'description_short'     => Schema::TYPE_TEXT,
            'description_full'      => Schema::TYPE_TEXT,

            'lat'                   => Schema::TYPE_STRING. '(20) NULL',
            'lng'                   => Schema::TYPE_STRING. '(20) NULL',

            'dialcode'              => Schema::TYPE_STRING. '(10) NULL',
            'alias'                 => Schema::TYPE_STRING. '(20) NULL',

            'files'                 => Schema::TYPE_TEXT. ' NULL', //

            'important'             => Schema::TYPE_SMALLINT . ' NOT NULL DEFAULT 0', //статус, активна некативна, удалено
            'status'                => Schema::TYPE_SMALLINT . ' NOT NULL DEFAULT 10', //статус, активна некативна, удалено

            'kladr_country_id'      => Schema::TYPE_INTEGER . ' NULL',
            'kladr_region_id'       => Schema::TYPE_INTEGER . ' NULL',

            'vk_id'                 => Schema::TYPE_INTEGER . ' NULL',
            'autoru_id'             => Schema::TYPE_INTEGER . ' NULL',

        ], $tableOptions);

        $this->execute("ALTER TABLE {{%kladr_city}} ADD INDEX(lat);");
        $this->execute("ALTER TABLE {{%kladr_city}} ADD INDEX(lng);");
        $this->execute("ALTER TABLE {{%kladr_city}} ADD INDEX(important);");
        $this->execute("ALTER TABLE {{%kladr_city}} ADD UNIQUE(autoru_id);");
        $this->execute("ALTER TABLE {{%kladr_city}} ADD UNIQUE(vk_id);");
        $this->execute("ALTER TABLE {{%kladr_city}} ADD INDEX(name);");
        $this->execute("ALTER TABLE {{%kladr_city}} ADD INDEX(name_full);");
        $this->execute("ALTER TABLE {{%kladr_city}} ADD INDEX(name_where);");

        $this->execute("ALTER TABLE {{%kladr_city}} ADD INDEX(alias);");
        $this->execute("ALTER TABLE {{%kladr_city}} ADD INDEX(dialcode);");

        $this->execute("ALTER TABLE {{%kladr_city}} ADD INDEX(status);");

        $this->execute("ALTER TABLE {{%kladr_city}} COMMENT = 'Районы';");


        $this->addForeignKey(
            'kladr_city__kladr_country_id', "{{%kladr_city}}",
            'kladr_country_id', '{{%kladr_country}}', 'id', 'CASCADE', 'CASCADE'
        );

        $this->addForeignKey(
            'kladr_city__kladr_region_id', "{{%kladr_city}}",
            'kladr_region_id', '{{%kladr_region}}', 'id', 'CASCADE', 'CASCADE'
        );

    }

    public function down()
    {
        $this->dropForeignKey("kladr_city__kladr_country_id", "{{%kladr_city}}");
        $this->dropForeignKey("kladr_city__kladr_region_id", "{{%kladr_city}}");

        $this->dropTable("{{%kladr_city}}");
    }
}
