<?php
/**
 * m150119_140559_create_table__kladr_road
 * 
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 22.01.2015
 * @since 1.0.0
 */
use yii\db\Schema;
use yii\db\Migration;

class m150119_140559_create_table__kladr_road extends Migration
{
    public function up()
    {
        $tableExist = $this->db->getTableSchema("{{%kladr_road}}", true);
        if ($tableExist)
        {
            return true;
        }

        $tableOptions = null;
        if ($this->db->driverName === 'mysql') {
            $tableOptions = 'CHARACTER SET utf8 COLLATE utf8_general_ci ENGINE=InnoDB';
        }

        $this->createTable("{{%kladr_road}}", [
            'id'                    => Schema::TYPE_PK,

            'name'                  => Schema::TYPE_STRING. '(255) NOT NULL',
            'alternative_name'      => Schema::TYPE_STRING. '(255) NOT NULL',

            'description_short'     => Schema::TYPE_TEXT,
            'description_full'      => Schema::TYPE_TEXT,

            'files'                 => Schema::TYPE_TEXT. ' NULL', //

            'status'                => Schema::TYPE_SMALLINT . ' NOT NULL DEFAULT 10', //статус, активна некативна, удалено

            'kladr_city_id'         => Schema::TYPE_INTEGER . ' NULL',

        ], $tableOptions);

        $this->execute("ALTER TABLE {{%kladr_road}} ADD INDEX(name);");
        $this->execute("ALTER TABLE {{%kladr_road}} ADD INDEX(alternative_name);");

        $this->execute("ALTER TABLE {{%kladr_road}} ADD INDEX(kladr_city_id);");
        $this->execute("ALTER TABLE {{%kladr_road}} ADD INDEX(status);");

        $this->execute("ALTER TABLE {{%kladr_road}} COMMENT = 'Шоссе';");


        $this->addForeignKey(
            'kladr_road__kladr_city_id', "{{%kladr_road}}",
            'kladr_city_id', '{{%kladr_city}}', 'id', 'CASCADE', 'CASCADE'
        );


    }

    public function down()
    {
        $this->dropForeignKey("kladr_road__kladr_city_id", "{{%kladr_road}}");

        $this->dropTable("{{%kladr_road}}");
    }
}
