<?php
/**
 * Country
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 20.01.2015
 * @since 1.0.0
 */

namespace skeeks\modules\cms\kladr\models;

use skeeks\cms\base\db\ActiveRecord;
use skeeks\cms\models\behaviors\HasDescriptionsBehavior;
use skeeks\cms\models\behaviors\HasStatus;

/**
 * Class Country
 * @package skeeks\modules\cms\kladr\models
 */
class Country extends ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return '{{%kladr_country}}';
    }

    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return array_merge(parent::behaviors(), [
            HasDescriptionsBehavior::className(),
            HasStatus::className() => HasStatus::className(),
        ]);
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return array_merge(parent::rules(), [
            [['name'], 'required'],
            [['domain'], 'unique'],
            [['name', 'name_full', 'name_where','domain'], 'string'],
            [['description_short', 'description_full', 'files', 'status', 'vk_id', 'autoru_id', 'lat', 'lng', 'dialcode', 'important'], 'safe'],
        ]);
    }


    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return  array_merge(parent::attributeLabels(), [
            'id' => \Yii::t('app', 'ID'),
            'name' => \Yii::t('app', 'Name'),
            'code' => \Yii::t('app', 'Code'),
            'name_full' => \Yii::t('app', 'Полное название'),
            'name_where' => \Yii::t('app', 'Название со склонением'),
            'domain' => \Yii::t('app', 'Код страны'),
            'dialcode' => \Yii::t('app', 'Номер телефона'),
            'description_short' => \Yii::t('app', 'Description Short'),
            'description_full' => \Yii::t('app', 'Description Full'),
            'files' => \Yii::t('app', 'Files'),
            'status' => \Yii::t('app', 'Status'),
        ]);
    }

}