<?php
/**
 * Metro
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 22.01.2015
 * @since 1.0.0
 */
namespace skeeks\modules\cms\kladr\models;

use skeeks\cms\base\db\ActiveRecord;
use skeeks\cms\models\behaviors\HasDescriptionsBehavior;
use skeeks\cms\models\behaviors\HasStatus;
use skeeks\cms\models\behaviors\Implode;

/**
 * Class AdministrativeArea
 * @package skeeks\modules\cms\kladr\models
 */
class Metro extends ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return '{{%kladr_metro}}';
    }

    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return array_merge(parent::behaviors(), [
            HasDescriptionsBehavior::className(),
            HasStatus::className() => HasStatus::className(),
        ]);
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return array_merge(parent::rules(), [
            [['name'], 'required'],
            [['kladr_city_id'], 'integer'],
            [['name', 'alternative_name'], 'string'],
            [['description_short', 'description_full', 'files', 'status', 'vk_id'], 'safe'],
        ]);
    }


    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return  array_merge(parent::attributeLabels(), [
            'id' => \Yii::t('app', 'ID'),
            'name' => \Yii::t('app', 'Name'),
            'codes' => \Yii::t('app', 'Codes'),
            'alternative_name' => \Yii::t('app', 'Alternative Name'),
            'description_short' => \Yii::t('app', 'Description Short'),
            'description_full' => \Yii::t('app', 'Description Full'),
            'files' => \Yii::t('app', 'Files'),
            'status' => \Yii::t('app', 'Status'),
        ]);
    }

}