<?php
/**
 * kladr
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 21.01.2015
 * @since 1.0.0
 */

use yii\helpers\Html;
use skeeks\cms\modules\admin\widgets\ActiveForm;
use skeeks\cms\models\Tree;

/* @var $this yii\web\View */
/* @var $model Tree */
/* @var $form \skeeks\cms\modules\admin\widgets\ActiveForm */

?>


<?php $form = ActiveForm::begin([
    'id' => 'kladr'
]); ?>

<label>Страна:</label>
<? echo \skeeks\widget\chosen\Chosen::widget([
        'name' => 'kladr_country_id',
        'items' => \yii\helpers\ArrayHelper::map(
            \skeeks\modules\cms\kladr\models\Country::find()->all(),
            'id', 'name'
        )
    ]);
?>

<label>Край:</label>
<select class="form-control" name="kladr_administrative_area_id"></select>


<label>Район:</label>
<select class="form-control" name="kladr_sub_administrative_area_id"></select>

<label>Город:</label>
<select class="form-control" name="kladr_locality_id"></select>

<label>Полный адрес:</label>
<input type="text" name="kladr_address" class="form-control" value="<?= $model->kladr_address; ?>"/>
<input type="hidden" name="kladr_lat" class="form-control" />
<input type="hidden" name="kladr_lon" class="form-control" />


<div id="sx-map" style="width: 100%; height: 300px"></div>



<?= Html::submitButton('Сохранить', ['class' => 'btn-primary btn'])?>
<?php ActiveForm::end(); ?>


<script src="//api-maps.yandex.ru/2.1/?load=package.full&lang=ru-RU" type="text/javascript"></script>
<?

$AdministrativeAreaBackend = \skeeks\cms\helpers\UrlHelper::construct('kladr/ajax/administrative-area')->toString();
$SubAdministrativeAreaBackend = \skeeks\cms\helpers\UrlHelper::construct('kladr/ajax/sub-administrative-area')->toString();
$localityBackend = \skeeks\cms\helpers\UrlHelper::construct('kladr/ajax/locality')->toString();



$this->registerJs(<<<JS
    (function(sx, $, _)
    {
        sx.createNamespace('classes', sx);

        sx.classes.Kladr = sx.classes.Widget.extend({

            _init: function()
            {},

            _onDomReady: function()
            {
                var self = this;
                this.Jkladr_country_id                  = $("[name=kladr_country_id]", this.getWrapper());
                this.Jkladr_administrative_area_id      = $("[name=kladr_administrative_area_id]", this.getWrapper());
                this.Jkladr_sub_administrative_area_id  = $("[name=kladr_sub_administrative_area_id]", this.getWrapper());
                this.Jkladr_locality_id                 = $("[name=kladr_locality_id]", this.getWrapper());

                this.Jkladr_country_id.on("change", function()
                {
                    self.updateCountry();
                    return false;
                });

                this.Jkladr_administrative_area_id.on("change", function()
                {
                    self.updateAdministrativeArea();
                    self.updateLocality();
                    return false;
                });
                this.Jkladr_sub_administrative_area_id.on("change", function()
                {
                    self.updateLocality();
                    return false;
                });
            },

            _onWindowReady: function()
            {},


            updateCountry: function()
            {
                var self = this;
                this.Jkladr_administrative_area_id.empty();
                this.Jkladr_sub_administrative_area_id.empty();
                this.Jkladr_locality_id.empty();

                var ajax = sx.ajax.preparePostQuery(this.get('AdministrativeAreaBackend'), {
                    'kladr_country_id': this.Jkladr_country_id.val()
                });

                ajax.onSuccess(function(e, data)
                {
                    if (data.response.items)
                    {
                        self.Jkladr_administrative_area_id.append('<option value=""> - </option>');
                        _.each(data.response.items, function(element, key)
                        {
                            self.Jkladr_administrative_area_id.append('<option value="' + element.id + '">' + element.name + '</option>')
                        });
                    }
                });

                ajax.execute();
            },


            updateAdministrativeArea: function()
            {
                var self = this;
                this.Jkladr_sub_administrative_area_id.empty();
                this.Jkladr_locality_id.empty();

                var ajax = sx.ajax.preparePostQuery(this.get('SubAdministrativeAreaBackend'), {
                    'kladr_administrative_area_id': this.Jkladr_administrative_area_id.val()
                });

                ajax.onSuccess(function(e, data)
                {
                    if (data.response.items)
                    {
                        self.Jkladr_sub_administrative_area_id.append('<option value=""> - </option>');
                        _.each(data.response.items, function(element, key)
                        {
                            self.Jkladr_sub_administrative_area_id.append('<option value="' + element.id + '">' + element.name + '</option>')
                        });
                    }
                });

                ajax.execute();
            },

            updateLocality: function()
            {
                var self = this;
                this.Jkladr_locality_id.empty();

                var ajax = sx.ajax.preparePostQuery(this.get('LocalityBackend'), {
                    'kladr_administrative_area_id': this.Jkladr_administrative_area_id.val(),
                    'kladr_sub_administrative_area_id': this.Jkladr_sub_administrative_area_id.val()
                });

                ajax.onSuccess(function(e, data)
                {
                    if (data.response.items)
                    {
                        self.Jkladr_locality_id.append('<option value=""> - </option>');
                        _.each(data.response.items, function(element, key)
                        {
                            self.Jkladr_locality_id.append('<option value="' + element.id + '">' + element.name + '</option>')
                        });
                    }
                });

                ajax.execute();
            }
        });

        sx.Kladr = new sx.classes.Kladr('#kladr',{
            'AdministrativeAreaBackend' : '$AdministrativeAreaBackend',
            'SubAdministrativeAreaBackend' : '$SubAdministrativeAreaBackend',
            'LocalityBackend' : '$localityBackend'
        });
    })(sx, sx.$, sx._);
JS
);
?>











<?/*= $form->field($model, 'kladr_address')->textInput(['maxlength' => 255]) */?><!--


--><?/*= $form->field($model, 'kladr_country_id')->widget(
    \skeeks\widget\chosen\Chosen::className(), [
        'items' => \yii\helpers\ArrayHelper::map(
            \skeeks\modules\cms\kladr\models\Country::find()->all(),
            'id', 'name'
        )
    ]);
*/?>

<?/*= $form->field($model, 'kladr_administrative_area_id')->widget(
    \skeeks\widget\chosen\Chosen::className(), [
        'items' => \yii\helpers\ArrayHelper::map(
            \skeeks\modules\cms\kladr\models\AdministrativeArea::find()->all(),
            'id', 'name'
        )
    ]);
*/?>

<?/*= $form->field($model, 'kladr_sub_administrative_area_id')->widget(
    \skeeks\widget\chosen\Chosen::className(), [
        'items' => \yii\helpers\ArrayHelper::map(
            \skeeks\modules\cms\kladr\models\SubAdministrativeArea::find()->all(),
            'id', 'name'
        )
    ]);

*/?>

<?/*= $form->field($model, 'kladr_locality_id')->widget(
    \yii\jui\AutoComplete::className(), [
        'source' => \yii\helpers\ArrayHelper::map(
            \skeeks\modules\cms\kladr\models\Locality::find()->all(),
            'id', 'name'
        )
    ]);
*/?>