

<?php
/**
 * index
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 30.10.2014
 * @since 1.0.0
 */
use skeeks\cms\modules\admin\widgets\GridView;

/* @var $this yii\web\View */
/* @var $searchModel common\models\searchs\Game */
/* @var $dataProvider yii\data\ActiveDataProvider */

?>

<?= GridView::widget([
    'dataProvider'  => $dataProvider,
    'filterModel'   => $searchModel,
    'columns' => [
        ['class' => 'yii\grid\SerialColumn'],

        [
            'class'         => \skeeks\cms\modules\admin\grid\ActionColumn::className(),
            'controller'    => $controller
        ],

        ///['class' => \skeeks\cms\grid\ImageColumn::className()],

        'name',
        'name_full',
        'name_where',
        'alias',
        'dialcode',
        'important',

        [
            'class'     => \yii\grid\DataColumn::className(),
            'value'     => function($model)
            {
                if ($model->kladr_country_id)
                {
                    $country = \skeeks\modules\cms\kladr\models\Country::find()->where(['id' => $model->kladr_country_id])->one();
                }

                if ($country)
                {
                    return $country->name;
                } else
                {
                    return '';
                }
            },
            'format' => 'html'
        ],

        [
            'class'     => \yii\grid\DataColumn::className(),
            'value'     => function($model)
            {
                if ($model->kladr_region_id)
                {
                    $country = \skeeks\modules\cms\kladr\models\Region::find()->where(['id' => $model->kladr_region_id])->one();
                }

                if ($country)
                {
                    return $country->name;
                } else
                {
                    return '';
                }
            },
            'format' => 'html'
        ],



        ['class' => \skeeks\cms\grid\StatusColumn::className()],



        //['class' => \skeeks\cms\grid\UpdatedAtColumn::className()],

       // ['class' => \skeeks\cms\grid\UpdatedByColumn::className()],
    ],
]); ?>
