<?php
/**
 * map
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 22.01.2015
 * @since 1.0.0
 */
/**
 * @var \skeeks\modules\cms\kladr\widgets\form\Select $widget
 * @var \skeeks\cms\base\db\ActiveRecord $model
 * @var $this yii\web\View
 */

$clientOptionsJson = \yii\helpers\Json::encode($clientOptions);


?>
<div id="<?= $id; ?>" class="sx-widget-select-kladr">
    <div class="row">
        <? if ($model->hasAttribute($widget->fieldNameCountry)) : ?>
            <div class="col-lg-4 sx-kladr-element-wrapper sx-visible">
                <label>Страна:</label>
                <?= \skeeks\widget\chosen\Chosen::widget([
                    'model' => $model,
                    'items' => \yii\helpers\ArrayHelper::map(
                        \skeeks\modules\cms\kladr\models\Country::find()->all(),
                        'id', 'name'
                    ),
                    'attribute' => $widget->fieldNameCountry
                ]);?>
            </div>
        <? endif; ?>

        <? if ($model->hasAttribute($widget->fieldNameRegion)) : ?>
            <div class="col-lg-4 sx-kladr-element-wrapper <?= $regionItems ? " sx-visible" : ""?>">
                <label>Регион:</label>
                <? echo \skeeks\widget\chosen\Chosen::widget([
                        'model' => $model,
                        'attribute' => $widget->fieldNameRegion,
                        'items' => $regionItems
                    ]);
                ?>
            </div>
        <? endif; ?>

        <? if ($model->hasAttribute($widget->fieldNameCity)) : ?>
            <div class="col-lg-4 sx-kladr-element-wrapper <?= $cityItems ? " sx-visible" : ""?>">
                <label>Город:</label>
                <? echo \skeeks\widget\chosen\Chosen::widget([
                        'model' => $model,
                        'attribute' => $widget->fieldNameCity,
                        'items' => $cityItems
                    ]);
                ?>
            </div>
        <? endif; ?>
    </div>
    <div class="row">
        <? if ($model->hasAttribute($widget->fieldNameMetro)) : ?>
            <div class="col-lg-4 sx-kladr-element-wrapper <?= $metroItems ? " sx-visible" : ""?>">
                <label>Метро:</label>
                <? echo \skeeks\widget\chosen\Chosen::widget([
                        'model' => $model,
                        'attribute' => $widget->fieldNameMetro,
                        'items' => $metroItems
                    ]);
                ?>
            </div>
        <? endif; ?>

        <? if ($model->hasAttribute($widget->fieldNameRoad)) : ?>
            <div class="col-lg-4 sx-kladr-element-wrapper <?= $roadItems ? " sx-visible" : ""?>">
                <label>Шоссе:</label>
                <? echo \skeeks\widget\chosen\Chosen::widget([
                        'model' => $model,
                        'attribute' => $widget->fieldNameRoad,
                        'items' => $roadItems
                    ]);
                ?>
            </div>
        <? endif; ?>
   </div>
</div>

<?= $this->registerJs(<<<JS
    (function(sx, $, _)
    {
        sx.createNamespace('classes.widgets', sx);

        sx.classes.widgets.KladrSelect = sx.classes.Widget.extend({

            _init: function()
            {},

            _onDomReady: function()
            {
                var self = this;

                this.Jcountry                   = $("#" + this.get('fieldNameCountryId'), this.getWrapper());
                this.Jregion                    = $("#" + this.get('fieldNameRegionId') + "", this.getWrapper());
                this.Jcity                      = $("#" + this.get('fieldNameCityId') + "", this.getWrapper());
                this.Jmetro                     = $("#" + this.get('fieldNameMetroId') + "", this.getWrapper());
                this.Jroad                      = $("#" + this.get('fieldNameRoadId') + "", this.getWrapper());

                this.Jcountry.on("change", function()
                {
                    self.trigger('change');

                    self
                        .hideElement(self.Jregion)
                        .hideElement(self.Jcity)
                        .hideElement(self.Jmetro)
                        .hideElement(self.Jroad)
                    ;

                    self.updatedRegions();
                    return false;
                });

                this.Jregion.on("change", function()
                {
                    self.trigger('change');

                    self
                        .hideElement(self.Jcity)
                        .hideElement(self.Jmetro)
                        .hideElement(self.Jroad)
                    ;
                    self.updatedCities();
                    return false;
                });

                this.Jcity.on("change", function()
                {
                    self.trigger('change');

                    self
                        .hideElement(self.Jmetro)
                        .hideElement(self.Jroad)
                    ;

                    self.updateMetro();
                    self.updateRoads();
                    return false;
                });
            },

            /**
            *
            * @param ajaxQuery
            * @returns {sx.classes.widgets.KladrSelect}
            */
            applyAjaxHendlers: function(ajaxQuery)
            {
                new sx.classes.AjaxHandlerNotifyErrors(ajaxQuery);
                new sx.classes.AjaxHandlerNoLoader(ajaxQuery);
                new sx.classes.AjaxHandlerBlocker(ajaxQuery, {
                    'wrapper': this.getWrapper()
                });

                return this;
            },


            updatedRegions: function()
            {
                var self = this;
                var ajax = sx.ajax.preparePostQuery(this.get('regionsBackendUrl'), {
                    'kladr_country_id': this.Jcountry.val()
                });

                this.applyAjaxHendlers(ajax);

                ajax.onSuccess(function(e, data)
                {
                    if (data.response.items && _.size(data.response.items)>0)
                    {
                        self.Jregion.empty();
                        self.showElement(self.Jregion);

                        self.Jregion.append('<option value=""> - </option>');
                        _.each(data.response.items, function(element, key)
                        {
                            self.Jregion.append('<option value="' + element.id + '">' + element.name + '</option>');
                        });

                        self.Jregion.trigger("chosen:updated");
                    }
                });

                ajax.execute();
            },

            updatedCities: function()
            {
                var self = this;
                var ajax = sx.ajax.preparePostQuery(this.get('citiesBackendUrl'), {
                    'kladr_region_id': this.Jregion.val()
                });

                this.applyAjaxHendlers(ajax);

                ajax.onSuccess(function(e, data)
                {
                    if (data.response.items && _.size(data.response.items)>0)
                    {
                        self.Jcity.empty();
                        self.showElement(self.Jcity);

                        self.Jcity.append('<option value=""> - </option>');
                        _.each(data.response.items, function(element, key)
                        {
                            self.Jcity.append('<option value="' + element.id + '">' + element.name + '</option>');
                        });

                        self.Jcity.trigger("chosen:updated");
                    }
                });

                ajax.execute();
            },

            updateMetro: function()
            {
                var self = this;
                var ajax = sx.ajax.preparePostQuery(this.get('metroBackendUrl'), {
                    'kladr_city_id': this.Jcity.val()
                });

                this.applyAjaxHendlers(ajax);

                ajax.onSuccess(function(e, data)
                {
                    if (data.response.items && _.size(data.response.items)>0)
                    {
                        self.Jmetro.empty();
                        self.showElement(self.Jmetro);

                        self.Jmetro.append('<option value=""> - </option>');
                        _.each(data.response.items, function(element, key)
                        {
                            self.Jmetro.append('<option value="' + element.id + '">' + element.name + '</option>');
                        });

                        self.Jmetro.trigger("chosen:updated");
                    }
                });

                ajax.execute();
            },

            updateRoads: function()
            {
                var self = this;
                var ajax = sx.ajax.preparePostQuery(this.get('roadsBackendUrl'), {
                    'kladr_city_id': this.Jcity.val()
                });

                this.applyAjaxHendlers(ajax);

                ajax.onSuccess(function(e, data)
                {
                    if (data.response.items && _.size(data.response.items)>0)
                    {
                        self.Jroad.empty();
                        self.showElement(self.Jroad);

                        self.Jroad.append('<option value=""> - </option>');
                        _.each(data.response.items, function(element, key)
                        {
                            self.Jroad.append('<option value="' + element.id + '">' + element.name + '</option>');
                        });

                        self.Jroad.trigger("chosen:updated");
                    }
                });

                ajax.execute();
            },


            hideElement: function(Jelement)
            {
                Jelement.closest('.sx-kladr-element-wrapper').removeClass('sx-visible');
                return this;
            },

            showElement: function(Jelement)
            {
                Jelement.closest('.sx-kladr-element-wrapper').addClass('sx-visible');
                return this;
            },


            _onWindowReady: function()
            {}
        });

        sx.widgetKladrSelect = new sx.classes.widgets.KladrSelect('#{$id}', {$clientOptionsJson});
    })(sx, sx.$, sx._);
JS
)?>